package hello;

import java.util.ArrayList;
import java.util.List;

import jakarta.persistence.CascadeType;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.OneToMany;

@Entity
public class Customer {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;
    private String firstName;
    private String lastName;
    @OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER, mappedBy = "customer", orphanRemoval = true)
    private List<ProductOrder> productOrder = new ArrayList<>(0);

    protected Customer() {
    }

    public Customer(String firstName, String lastName) {
        this.firstName = firstName;
        this.lastName = lastName;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        final int maxLen = 10;
        return String.format("Customer [id=%s, firstName=%s, lastName=%s, productOrder=%s]", id, firstName, lastName,
                productOrder != null ? productOrder.subList(0, Math.min(productOrder.size(), maxLen)) : null);
    }

    /**
     * @return the productOrder
     */
    public List<ProductOrder> getProductOrder() {
        return productOrder;
    }

    /**
     * @param productOrder
     *            the productOrder to set
     */
    public void setProductOrder(List<ProductOrder> productOrder) {
        this.productOrder = productOrder;
    }

}
