package hello;

import java.util.List;

import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;

public interface CustomerRepository extends CrudRepository<Customer, Long> {

    List<Customer> findByLastName(String lastName);

    @Query(value = "select p from Customer c join c.productOrder p where p.delayed = true")
    List<ProductOrder> findDelayedOrders(Pageable pageable);

}
