package hello;

import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.ForeignKey;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;

@Entity
public class ProductOrder {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;
    private int lineItems;
    private boolean delayed;
    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "CUSTOMER_ID", foreignKey = @ForeignKey(name = "FK_CUSTOMER_PROD_ORD"))
    private Customer customer;

    protected ProductOrder() {
    }

    public ProductOrder(int lineItems, Customer customer, boolean delayed) {
        this.lineItems = lineItems;
        this.customer = customer;
        this.delayed = delayed;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return String.format("ProductOrder [id=%s, lineItems=%s, customer=%s, delayed=%s]", id, lineItems, customer,
                delayed);
    }

}
